/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20140926-64 [Oct  1 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembly of ssdt3.dat, Wed Apr 22 12:35:32 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000696 (1686)
 *     Revision         0x01
 *     Checksum         0x6D
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "CB-01   "
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("ssdt3.aml", "SSDT", 1, "LENOVO", "CB-01   ", 0x00000001)
{
    /*
     * iASL Warning: There were 5 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (GDMA, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (GPI0, MethodObj)    // Warning: Unresolved method, guessing 4 arguments
    External (SDMA, MethodObj)    // Warning: Unresolved method, guessing 3 arguments
    External (SFLG, MethodObj)    // Warning: Unresolved method, guessing 5 arguments
    External (SPIO, MethodObj)    // Warning: Unresolved method, guessing 3 arguments

    External (_SB_.PCI0, DeviceObj)
    External (GNVS, OpRegionObj)

    Scope (\_SB.PCI0)
    {
        Device (SAT2)
        {
            Field (GNVS, AnyAcc, Lock, Preserve)
            {
                Offset (0x1FA), 
                PFT0,   1, 
                PIE0,   1, 
                PPE0,   1, 
                PDE0,   1, 
                PFT1,   1, 
                PIE1,   1, 
                PPE1,   1, 
                PDE1,   1, 
                PRT0,   2, 
                    ,   2, 
                PIP0,   2, 
                PSIT,   1, 
                Offset (0x1FC), 
                SFT0,   1, 
                SIE0,   1, 
                SPE0,   1, 
                SDE0,   1, 
                SFT1,   1, 
                SIE1,   1, 
                SPE1,   1, 
                SDE1,   1, 
                SRT0,   2, 
                    ,   2, 
                SIP0,   2, 
                SSIT,   1, 
                Offset (0x1FE)
            }

            OperationRegion (IDER, PCI_Config, 0x40, 0x20)
            Field (IDER, AnyAcc, NoLock, Preserve)
            {
                    ,   15, 
                PIDE,   1, 
                    ,   15, 
                SIDE,   1, 
                PRT1,   2, 
                PIP1,   2, 
                SRT1,   2, 
                SIP1,   2, 
                Offset (0x08), 
                UDM0,   1, 
                UDM1,   1, 
                UDM2,   1, 
                UDM3,   1, 
                Offset (0x0A), 
                PCT0,   2, 
                    ,   2, 
                PCT1,   2, 
                Offset (0x0B), 
                SCT0,   2, 
                    ,   2, 
                SCT1,   2, 
                Offset (0x14), 
                PCB0,   1, 
                PCB1,   1, 
                SCB0,   1, 
                SCB1,   1, 
                PCCR,   2, 
                SCCR,   2, 
                    ,   4, 
                PUM0,   1, 
                PUM1,   1, 
                SUM0,   1, 
                SUM1,   1, 
                PSIG,   2, 
                SSIG,   2, 
                UMT0,   1, 
                UMT1,   1, 
                UMT2,   1, 
                UMT3,   1
            }

            Name (_ADR, 0x001F0005)  // _ADR: Address
            Device (PRID)
            {
                Name (_ADR, Zero)  // _ADR: Address
                Name (TDM0, Zero)
                Name (TPI0, Zero)
                Name (TDM1, Zero)
                Name (TPI1, Zero)
                Method (_GTM, 0, NotSerialized)  // _GTM: Get Timing Mode
                {
                    Name (PBUF, Buffer (0x14)
                    {
                        /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /* ........ */
                        /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /* ........ */
                        /* 0010 */  0x00, 0x00, 0x00, 0x00                           /* .... */
                    })
                    CreateDWordField (PBUF, Zero, PIO0)
                    CreateDWordField (PBUF, 0x04, DMA0)
                    CreateDWordField (PBUF, 0x08, PIO1)
                    CreateDWordField (PBUF, 0x0C, DMA1)
                    CreateDWordField (PBUF, 0x10, FLAG)
                    Store (GPI0 (PFT0, PDE0, PRT0, PIP0), PIO0) /* \_SB_.PCI0.SAT2.PRID._GTM.PIO0 */
                    If (And (PSIT, One))
                    {
                        Store (GPI0 (PFT1, PDE1, PRT1, PIP1), PIO1) /* \_SB_.PCI0.SAT2.PRID._GTM.PIO1 */
                    }
                    Else
                    {
                        Store (GPI0 (PFT1, PDE1, PRT0, PIP0), PIO1) /* \_SB_.PCI0.SAT2.PRID._GTM.PIO1 */
                    }

                    Store (GDMA (UDM0, PUM0), DMA0) /* \_SB_.PCI0.SAT2.PRID._GTM.DMA0 */
                    If (LAnd (LEqual (DMA0, 0x14), UMT0))
                    {
                        Store (0x0F, DMA0) /* \_SB_.PCI0.SAT2.PRID._GTM.DMA0 */
                    }

                    If (LGreater (DMA0, PIO0))
                    {
                        Store (PIO0, DMA0) /* \_SB_.PCI0.SAT2.PRID._GTM.DMA0 */
                    }

                    Store (GDMA (UDM1, PUM1), DMA1) /* \_SB_.PCI0.SAT2.PRID._GTM.DMA1 */
                    If (LAnd (LEqual (DMA1, 0x14), UMT1))
                    {
                        Store (0x0F, DMA1) /* \_SB_.PCI0.SAT2.PRID._GTM.DMA1 */
                    }

                    If (LGreater (DMA1, PIO1))
                    {
                        Store (PIO1, DMA1) /* \_SB_.PCI0.SAT2.PRID._GTM.DMA1 */
                    }

                    Store (SFLG (PIE0, UDM0, PIE1, UDM1, One), FLAG) /* \_SB_.PCI0.SAT2.PRID._GTM.FLAG */
                    Return (PBUF) /* \_SB_.PCI0.SAT2.PRID._GTM.PBUF */
                }

                Method (_STM, 3, NotSerialized)  // _STM: Set Timing Mode
                {
                    CreateDWordField (Arg0, Zero, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    CreateWordField (Arg1, 0x6A, RPS0)
                    CreateWordField (Arg1, 0x80, IOM0)
                    CreateWordField (Arg1, 0xB0, DMM0)
                    CreateWordField (Arg2, 0x6A, RPS1)
                    CreateWordField (Arg2, 0x80, IOM1)
                    CreateWordField (Arg2, 0xB0, DMM1)
                    Name (IOTM, Buffer (0x05)
                    {
                         0x00, 0x00, 0x00, 0x00                           /* .... */
                    })
                    CreateByteField (IOTM, Zero, RCT)
                    CreateByteField (IOTM, One, ISP)
                    CreateByteField (IOTM, 0x02, FAST)
                    CreateByteField (IOTM, 0x03, DMAE)
                    CreateByteField (IOTM, 0x04, TPIO)
                    Name (DMAT, Buffer (0x05)
                    {
                         0x00, 0x00, 0x00, 0x00                           /* .... */
                    })
                    CreateByteField (DMAT, Zero, PCT)
                    CreateByteField (DMAT, One, PCB)
                    CreateByteField (DMAT, 0x02, UDMT)
                    CreateByteField (DMAT, 0x03, UDME)
                    CreateByteField (DMAT, 0x04, TDMA)
                    Store (SPIO (PIO0, RPS0, IOM0), IOTM) /* \_SB_.PCI0.SAT2.PRID._STM.IOTM */
                    If (Or (DMAE, FAST))
                    {
                        Store (RCT, PRT0) /* \_SB_.PCI0.SAT2.PRT0 */
                        Store (ISP, PIP0) /* \_SB_.PCI0.SAT2.PIP0 */
                        Store (FAST, PFT0) /* \_SB_.PCI0.SAT2.PFT0 */
                        Store (DMAE, PDE0) /* \_SB_.PCI0.SAT2.PDE0 */
                        Store (TPIO, TPI0) /* \_SB_.PCI0.SAT2.PRID.TPI0 */
                    }

                    Store (SPIO (PIO1, RPS1, IOM1), IOTM) /* \_SB_.PCI0.SAT2.PRID._STM.IOTM */
                    If (Or (DMAE, FAST))
                    {
                        Store (FAST, PFT1) /* \_SB_.PCI0.SAT2.PFT1 */
                        Store (DMAE, PDE1) /* \_SB_.PCI0.SAT2.PDE1 */
                        Store (TPIO, TPI1) /* \_SB_.PCI0.SAT2.PRID.TPI1 */
                        If (And (PSIT, One))
                        {
                            Store (RCT, PRT1) /* \_SB_.PCI0.SAT2.PRT1 */
                            Store (ISP, PIP1) /* \_SB_.PCI0.SAT2.PIP1 */
                        }
                        Else
                        {
                            Store (RCT, PRT0) /* \_SB_.PCI0.SAT2.PRT0 */
                            Store (ISP, PIP0) /* \_SB_.PCI0.SAT2.PIP0 */
                        }
                    }

                    If (And (FLAG, One))
                    {
                        Store (SDMA (DMA0, RPS0, DMM0), DMAT) /* \_SB_.PCI0.SAT2.PRID._STM.DMAT */
                        Store (PCT, PCT0) /* \_SB_.PCI0.SAT2.PCT0 */
                        Store (PCB, PCB0) /* \_SB_.PCI0.SAT2.PCB0 */
                        Store (UDME, UDM0) /* \_SB_.PCI0.SAT2.UDM0 */
                        Store (UDMT, PUM0) /* \_SB_.PCI0.SAT2.PUM0 */
                        Store (TDMA, TDM0) /* \_SB_.PCI0.SAT2.PRID.TDM0 */
                    }
                    Else
                    {
                        Store (Zero, UDM0) /* \_SB_.PCI0.SAT2.UDM0 */
                    }

                    If (And (FLAG, 0x04))
                    {
                        Store (SDMA (DMA1, RPS1, DMM1), DMAT) /* \_SB_.PCI0.SAT2.PRID._STM.DMAT */
                        Store (PCT, PCT1) /* \_SB_.PCI0.SAT2.PCT1 */
                        Store (PCB, PCB1) /* \_SB_.PCI0.SAT2.PCB1 */
                        Store (UDME, UDM1) /* \_SB_.PCI0.SAT2.UDM1 */
                        Store (UDMT, PUM1) /* \_SB_.PCI0.SAT2.PUM1 */
                        Store (TDMA, TDM1) /* \_SB_.PCI0.SAT2.PRID.TDM1 */
                    }
                    Else
                    {
                        Store (Zero, UDM1) /* \_SB_.PCI0.SAT2.UDM1 */
                    }

                    If (And (FLAG, 0x02))
                    {
                        Store (One, PIE0) /* \_SB_.PCI0.SAT2.PIE0 */
                    }

                    If (And (FLAG, 0x08))
                    {
                        Store (One, PIE1) /* \_SB_.PCI0.SAT2.PIE1 */
                    }
                }

                Device (MAST)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                    {
                        Name (ATA0, Buffer (0x0E)
                        {
                            /* 0000 */  0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x03,  /* ........ */
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF               /* ...... */
                        })
                        CreateByteField (ATA0, One, PIO0)
                        CreateByteField (ATA0, 0x08, DMA0)
                        Store (TPI0, PIO0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.PIO0 */
                        Or (PIO0, 0x08, PIO0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.PIO0 */
                        If (And (UDM0, One))
                        {
                            Store (TDM0, DMA0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.DMA0 */
                            Or (DMA0, 0x40, DMA0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.DMA0 */
                        }
                        Else
                        {
                            Store (TPI0, DMA0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.DMA0 */
                            If (LNotEqual (DMA0, Zero))
                            {
                                Subtract (DMA0, 0x02, DMA0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.DMA0 */
                            }

                            Or (DMA0, 0x20, DMA0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.DMA0 */
                        }

                        Return (ATA0) /* \_SB_.PCI0.SAT2.PRID.MAST._GTF.ATA0 */
                    }
                }

                Device (SLAV)
                {
                    Name (_ADR, One)  // _ADR: Address
                    Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
                    {
                        Name (ATA1, Buffer (0x0E)
                        {
                            /* 0000 */  0x03, 0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF, 0x03,  /* ........ */
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xB0, 0xEF               /* ...... */
                        })
                        CreateByteField (ATA1, One, PIO1)
                        CreateByteField (ATA1, 0x08, DMA1)
                        Store (TPI1, PIO1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.PIO1 */
                        Or (PIO1, 0x08, PIO1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.PIO1 */
                        If (And (UDM1, One))
                        {
                            Store (TDM1, DMA1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.DMA1 */
                            Or (DMA1, 0x40, DMA1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.DMA1 */
                        }
                        Else
                        {
                            Store (TPI1, DMA1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.DMA1 */
                            If (LNotEqual (DMA1, Zero))
                            {
                                Subtract (DMA1, 0x02, DMA1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.DMA1 */
                            }

                            Or (DMA1, 0x20, DMA1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.DMA1 */
                        }

                        Return (ATA1) /* \_SB_.PCI0.SAT2.PRID.SLAV._GTF.ATA1 */
                    }
                }
            }
        }
    }
}

